<?php
/*
Plugin Name: WP-GreyBox
Plugin URI: http://grupenet.com/2007/06/11/wp-greybox/
Description: <a href="http://orangoo.com/labs/GreyBox/">GreyBox</a> can be used to display websites, images and other content using AJAX. All images in each post are grouped together into a gallery automatically. GreyBox is a creation of <a href="http://amix.dk/">Amir Salihefendic</a>. WP-GreyBox may differ slightly from the original GreyBox due to optimizations in the code.
Version: 1.1.1
Author: Jared Schwager
Author URI: http://grupenet.com
*/

define("IMAGE_EXTENSIONS", 'jpg|jpeg|png|gif|bmp|ico');
function greybox_replace($content){
	global $post;
	preg_match_all('/<a(.*?)href=[\s\"\'\`](.*?)[\"\'\`](.*?)>/i', $content, $matches);	
	foreach($matches[0] as $match){
		if(preg_match('/href=[\s\"\'\`]+.*('.IMAGE_EXTENSIONS.')[\"\'\`]/i', $match)){
			if(preg_match('/rel=[\s\"\'\`]gb_imageset(.*?)[\"\'\`]/i', $match) == false){
				$addrel = str_replace('>', ' rel=\'gb_imageset['.$post->post_name.']\'>', $match);
				$content = str_replace($match, $addrel, $content);	
			}
		}
	}
	return $content;
}
function greybox_head(){
	$greybox_path = get_settings('siteurl')."/wp-content/plugins/wp-greybox/";
?>
<script type="text/javascript">var GB_ROOT_DIR = "<?php echo $greybox_path; ?>";</script>
<script type="text/javascript" src="<?php echo $greybox_path; ?>AJS.js"></script>
<script type="text/javascript" src="<?php echo $greybox_path; ?>AJS_fx.js"></script>
<script type="text/javascript" src="<?php echo $greybox_path; ?>gb_scripts.js"></script>
<link href="<?php echo $greybox_path; ?>gb_styles.css" rel="stylesheet" type="text/css" media="screen" />
<?php
}
add_filter('the_content', 'greybox_replace');
add_action('wp_head', 'greybox_head');
?>